pub fn is_anagram(a: String, b: String) -> bool {
  // Both strings must have the same length otherwise they can't be anagrams.
  if a.len() != b.len() {
    return false;
  }

  // Sort both strings' characters so they're in alphabetical order.
  let mut a = a.chars().collect::<Vec<_>>();
  a.sort_unstable();

  let mut b = b.chars().collect::<Vec<_>>();
  b.sort_unstable();

  // And if they are equal, then they're anagrams.
  a == b
}
